// Checks whether a character is a DBCS character or not
function isDBCSChar(unichar, isDBCSSession, isDBCSEuro, CodePage)
{
    if (!isDBCSSession) return false;
    if (useAccentedCharacters && ('\u0080' <= unichar) && (unichar <= '\u00FF')) return false;
    if (unichar == '\u20a9') return false;
    if (unichar == '\u20ac') {
        if (isDBCSEuro) return true;
        else return false;
    }
    if((unichar == '\u00a6') && (CodePage == 1390 || CodePage == 1399)) return true;
    if ('\u0080' <= unichar && unichar <= '\u00A1'
        || '\u00A4' == unichar
        || '\u00A7' <= unichar && unichar <= '\u00AB'
        || '\u00AD' <= unichar && unichar <= '\u00AE'
        || '\u00B0' <= unichar && unichar <= '\u04FF'
        || '\u0600' <= unichar && unichar <= '\u06FF'
        || '\u0F00' <= unichar && unichar <= '\u0FFF'
        || '\u1100' <= unichar && unichar <= '\u11FF'
        || '\u1800' <= unichar && unichar <= '\u18FF'
        || '\u1E00' <= unichar && unichar <= '\u27BF'
        || '\u2900' <= unichar && unichar <= '\u29FF'//$$38861f_1$$//
        || '\u2E80' <= unichar && unichar <= '\u2EF3'
        || '\u2ff0' <= unichar && unichar <= '\u2ffb'
        || '\u3000' <= unichar && unichar <= '\u33FF'
        || '\u3400' <= unichar && unichar <= '\u4DFF'
        || '\u4E00' <= unichar && unichar <= '\u9FA5'
        || '\uA000' <= unichar && unichar <= '\uA4FF'
        || '\uAC00' <= unichar && unichar <= '\uD7A3'
        || '\uD800' <= unichar && unichar <= '\uDFFF' //$$38841$$//
        || '\uE000' <= unichar && unichar <= '\uF86F'
        || '\uF900' <= unichar && unichar <= '\uFB4F'
        || '\uFB50' <= unichar && unichar <= '\uFDFF'
        || '\uFE20' <= unichar && unichar <= '\uFE6F'
        || '\uFE70' <= unichar && unichar <= '\uFEFF'
        || '\uFF00' <= unichar && unichar <= '\uFF60' //$$38861f_1$$//
        || '\uFFE0' <= unichar && unichar <= '\uFFE6'
        || '\uFFF0' <= unichar && unichar <= '\uFFFF') return true;

    return false;
}

//$$38841add start$$//
/**
 *  DBCS Combination Characters for JIS2004 support
 */
var CombinationCharTable = [
//====HiByte===LowByte==
    ['\u00E6','\u0300'],
    ['\u0254','\u0300'],
    ['\u0254','\u0301'],
    ['\u0259','\u0300'],
    ['\u0259','\u0301'],
    ['\u025A','\u0300'],
    ['\u025A','\u0301'],
    ['\u028C','\u0300'],
    ['\u028C','\u0301'],
    ['\u02E5','\u02E9'],
    ['\u02E9','\u02E5'],
    ['\u304B','\u309A'],
    ['\u304D','\u309A'],
    ['\u304F','\u309A'],
    ['\u3051','\u309A'],
    ['\u3053','\u309A'],
    ['\u30AB','\u309A'],
    ['\u30AD','\u309A'],
    ['\u30AF','\u309A'],
    ['\u30B1','\u309A'],
    ['\u30B3','\u309A'],
    ['\u30BB','\u309A'],
    ['\u30C4','\u309A'],
    ['\u30C8','\u309A'],
    ['\u31F7','\u309A']
];

function isHighSurrogate(unichar)
{
        if( '\uD800' <= unichar && unichar <= '\uDBFF')
        return true;

    //Check if the combination characters
    for( var i=0; i<CombinationCharTable.length; i++ ) {
        if( unichar == CombinationCharTable[i][0] )
            return true;
    }
    return false;
}

function isLowSurrogate(unichar)
{
    if( '\uDC00' <= unichar && unichar <= '\uDFFF')
        return true;

    //Check if the combination characters
    for( var i=0; i<CombinationCharTable.length; i++ ) {
        if( unichar == CombinationCharTable[i][1] )
            return true;
    }
    return false;
}

function isSurrogate(highchar, lowchar)
{
    if( '\uD800' <= highchar && highchar <= '\uDBFF' && '\uDC00' <= lowchar && lowchar <= '\uDFFF')
        return true;

    //Check if the combination characters
    for( var i=0; i<CombinationCharTable.length; i++ ) {
        if( highchar == CombinationCharTable[i][0] && lowchar == CombinationCharTable[i][1])
            return true;
    }
    return false;
}
//$$38841add end$$//

function allowDBCSOnly3270(event) {
    allowGField(event);
}

function allowDBCSPure(event) {
    allowGField(event);
}

function allowDBCSOnly3270ForIEMobile(inputbox) {
    allowGFieldForIEMobile(inputbox);
}

function allowDBCSPureForIEMobile(inputbox) {
    allowGFieldForIEMobile(inputbox);
}

// Allows only DBCS character event
function allowGField(event)
{
    event = (event) ? event : ((window.event) ? window.event : "");
    var code = event.keyCode ? event.keyCode : event.which;
    var element = (isIE) ? event.srcElement : event.target; //$$38158$$//
    var iname = element.name;                               //$$38158$$//
    var ipool = iname.split("_");                           //$$38158$$//
    var ipos = parseInt(ipool[1]);                          //$$38158$$//
    var ilen = parseInt(ipool[2]);                          //$$38158$$//

    if(enableAutoConvertSBCStoDBCS && isIE && event.type == "keypress") {
        if(code == 32) {
            event.keyCode = 0x3000;
            event.returnValue = true;
        } else if(code >= 33 && code <=126) {
            event.keyCode = 65281 + (code - 33);
            event.returnValue = true;
            return;
        }
    }

    var ck = function(code) {
        if (isDBCSChar(String.fromCharCode(code), enableDBCSSession, enableDBCSEuro, CodePage)) return true;
        return false;
    };
    contentCheck(event, ck);
    if(isIE && enableDBCSSession && element.getAttribute("eliminateMaxlengthInIdeographicFields") == "true") {            //$$38158$$//
      //if(autoAdvance && (event.type == "keyup" && code == 13) && getCurrentPosition() == element.value.length) {        //$$38158 IC59165del$$//
      if(autoAdvance && (event.type == "keyup" && !isIMEstate) && getCurrentPosition() == element.value.length) {         //$$IC59165$$//
            dataLengthCheckingForDBCSPure(element,true);                                                                  //$$38158$$//
        }                                                                                                                 //$$38158$$//
        else {                                                                                                            //$$38158$$//
          //if((event.type == "keydown" && code == 9) || (event.type == "keyup" && code == 13) || event.type == "blur") { //$$38158 IC59165del$$//
            if((event.type == "keydown" && code == 9) || (event.type == "keyup" && !isIMEstate) || event.type == "blur") {//$IC59165$//
                var a = " "+element.onkeypress;                                                                           //$$38158$$//
                if(a.indexOf("allowDBCSOnly5250")!=-1) //J field without SOSI                                             //$$38158$$//
                    dataLengthCheckingForDBCSOnly(element,false);                                                         //$$38158$$//
                else                                                                                                      //$$38158$$//
                    dataLengthCheckingForDBCSPure(element,false);                                                         //$$38158$$//
             }                                                                                                            //$$38158$$//
         }                                                                                                                //$$38158$$//
    }                                                                                                                     //$$38158$$//
    //$$38841add start$$//
    else if((CodePage == 1390 || CodePage == 1399) &&
           ((event.type == "keydown" && (code == 13 || code == 19 || code == 27 || code == 33 || code == 34 || (code > 111 && code < 124)))
         || (event.type == "keyup" && code == 13) || event.type == "click" || event.type == "blur")) {
        var isWithinInputSize = false;
        var isAlmostWithinInputSize = false;
        var value = element.value;
        var tempValue = element.value;
        var i = value.length - 1;
        //$$38862add start$$//
        var a = " "+element.onkeypress;
        if(a.indexOf("allowDBCSOnly5250")!=-1) {//J field without SOSI
            if(countDataLengthForDBCS(value) > ilen - 2) {
                while(isWithinInputSize == false && i > -1) {
                    if (isAlmostWithinInputSize == true) {
                        isWithinInputSize = true;
                        break;
                    }
                    //if last character is surrogate character, remove high and low character together
                    if(isSurrogate(value.substr(value.length-2,1), value.substr(value.length-1,1))) {
                        i--;
                        value = value.substr(0, i);
                    } else {
                        value = value.substr(0, i);
                    }
                    if (countDataLengthForDBCS(value) <= ilen - 2) {
                        isAlmostWithinInputSize = true;
                    }
                    i--;
                }
            }
        } else { //$$38862add end$$//
            if(countDataLengthForDBCS(value) > ilen) {
                while(isWithinInputSize == false && i > -1) {
                    if (isAlmostWithinInputSize == true) {
                        isWithinInputSize = true;
                        break;
                    }
                    //if last character is surrogate character, remove high and low character together
                    if(isSurrogate(value.substr(value.length-2,1), value.substr(value.length-1,1))) {
                        i--;
                        value = value.substr(0, i);
                    } else {
                        value = value.substr(0, i);
                    }
                    if (countDataLengthForDBCS(value) <= ilen) {
                        isAlmostWithinInputSize = true;
                    }
                    i--;
                }
            }
        }
        if(tempValue != value)
            element.value = value;
    }
    //$$38841add end$$//
}

// Allows only DBCS character event for IE Mobile
function allowGFieldForIEMobile(inputbox)
{

    if(enableAutoConvertSBCStoDBCS) {
        var content = inputbox.value;
        var data = "";
        for(var a = 0; a < content.length; a++) {
            var code = content.charCodeAt(a);
            if(code == 32) {
                code = 0x3000;
            }
            else if(code >= 33 && code <=126) {
                code = 65281 + (code - 33);
            }
            data += String.fromCharCode(code);
        }
        inputbox.value = data;
    }

    var ck = function(code) {
        if (isDBCSChar(String.fromCharCode(code), enableDBCSSession, enableDBCSEuro, CodePage)) return true;
        return false;
    };
    contentCheckForIEMobile(inputbox, ck);
}

function allowDBCSOnly5250(event) {
    allowJField(event);
}

function allowDBCSOnly5250ForIEMobile(inputbox) {
    allowJFieldForIEMobile(inputbox);
}

// Allows only DBCS character event
function allowJField(event)
{
    if(showUnProtectedSosiAsSpace && event.type != "keypress") { //$for event other than keypress and show SOSI is on$//
        event = (event) ? event : ((window.event) ? window.event : "");
            var code = event.keyCode ? event.keyCode : event.which;
        var element = (isIE) ? event.srcElement : event.target; //$$38158$$//
        var iname = element.name;                               //$$38158$$//
        var ipool = iname.split("_");                           //$$38158$$//
        var ipos = parseInt(ipool[1]);                          //$$38158$$//
        var ilen = parseInt(ipool[2]);                          //$$38158$$//

            //$Verify the text character by character with the "ck" function$//
        var verifyText = function(inStr, ck) {
            var outStr = "";
            for (var i=0; i< inStr.length; i++)
            {
              if (ck(inStr.charCodeAt(i))) outStr += inStr.charAt(i);
              //else break;  //$$38371$$//
              else continue; //$$38371$$//
            }
            return outStr;
        };

        //$function to remove any SBCS spaces in string$//
        var removeSpaces = function(inStr) {
          var outStr = "";
          for (var i=0; i< inStr.length; i++) {
            if (inStr.charCodeAt(i) != 32) outStr += inStr.charAt(i);
          }
          return outStr;
        };

        var ck = function(code) {
            if (isDBCSChar(String.fromCharCode(code), enableDBCSSession, enableDBCSEuro, CodePage)) return true;
            return false;
        };

        if(event.type == "paste" || event.type == "drop" || (event.type == "focus" && exceedString != null)) { //$Check the pasted/drop/exceed text is valid or not. The cursor position will be after last character after paste/drop/exceed$// //$$38158 modify$$//
            //$This is a Win IE only featurre$//
            if (!isIE || MAC) return;
            //$Find the caret position in the input field, the cPos varaible is what we need$//
            var caretPos = document.selection.createRange().duplicate();
            var selectText = document.selection.createRange().text;
            var t = caretPos.parentElement();
            var beginField = t.createTextRange();
            caretPos.collapse();
            beginField.collapse();
            var slen = t.value.length;
            var cPos = 0;
            var newPos = 0; //$$IC59163$$//
            for (; cPos <= slen ; cPos++ ) {
                qa =caretPos.getBoundingClientRect();
                qb = beginField.getBoundingClientRect();
                if ( qa.left == qb.left ) break;
                caretPos.move("character",-1);
            }
            //$remove SO/SI and adjust cursor position$//
            if(t.value.length > 0) {
                if(t.value.charCodeAt(0) == 32) { //$remove Shift-out$//
                    if(cPos > 0) cPos--;
                    t.value = t.value.substring(1, t.value.length);
                }
                if(t.value.charCodeAt(t.value.length-1) == 32) { //$remove Shift-in$//
                    if(cPos > t.value.length-1) cPos--;
                    t.value = t.value.substring(0, t.value.length-1);
                }
            }
            slen = t.value.length;

            //$verify text to be pasted/dropped$//
            var pText = "";
            if(event.type == "paste"){
                var data="";
                try{
                    if(clipboardData){
                        data=clipboardData.getData("Text");
                     }
                     if(data){
                         pText = verifyText(removeSpaces(data),ck);
                     }
                 }catch(e){}
                 //pText = verifyText(removeSpaces(clipboardData.getData("Text")),ck);
            }
            else if (event.type == "drop"){
                var data="";
                try{
                    if(event.dataTransfer){
                        data=event.dataTransfer.getData("Text");
                    }
                    if(data){
                        pText = verifyText(removeSpaces(data),ck);
                    }
                }catch(e){}
                //pText = verifyText(removeSpaces(event.dataTransfer.getData("Text")),ck);
            }
            else if (event.type == "focus" && exceedString != null) {                 //$$38158$$//
                //var data="";                                         //$$IC58950$$//
                //try{                                                 //$$IC589504$//
                //    if(clipboardData){                                              //$$IC58950$$//
                //        data=clipboardData.getData("Text");                         //$$IC58950$$//
                //    }                                                               //$$IC58950$$//
                //    if(data){                                                       //$$IC58950$$//
                //        pText = verifyText(removeSpaces(data),ck);                  //$$IC58950$$//
                //    }                                                               //$$IC58950$$//
                //}catch(e){}                                                         
                //pText = verifyText(removeSpaces(clipboardData.getData("Text")),ck); //$$38158add IC56690del$$//
                //exceedString = false;                                               //$$38158add IC58950del$$//
                pText = verifyText(removeSpaces(exceedString),ck);                    //$$IC58950$$//
                exceedString = null;                                                  //$$IC58950$$//
            }                                                                         //$$38158$$//
            //$Overrride default paste behaivor with above algorithm$//
            if(pText.length > 0 && selectText == "") {
                if(isOverWriteMode()) {
                    //$If overwrite mode enabled, overwrite current content with clipboard text and trim to field max length$//
                    if(cPos + pText.length > slen) {
                        t.value = t.value.substring(0,cPos) + pText;
                    } else {
                        t.value = t.value.substring(0,cPos) + pText + t.value.substring(cPos + pText.length ,slen);
                        newPos = cPos+pText.length; //$$IC59163$$//
                    }
                } else {
                    //$If insert mode enabled, insert proper legth of text in clip board$//
                    if(t.getAttribute("eliminateMaxlengthInIdeographicFields") == "true") {                                               //$$38158$$//
                        var iname = t.name;                                                                                               //$$38158$$//
                        var pool = iname.split("_");                                                                                      //$$38158$$//
                        var inputSize = parseInt(pool[2]);                                                                                //$$38158$$//
                        t.value = t.value.substring(0,cPos) + pText.substring(0,(inputSize/2) - 2 - slen) + t.value.substring(cPos,slen); //$$38158$$//
                        newPos = cPos+pText.substring(0,(inputSize/2) - 2 - slen).length;                                                 //$$IC59163$$//
                    }                                                                                                                     //$$38158$$//
                    else                                                                                                                  //$$38158$$//
                        t.value = t.value.substring(0,cPos) + pText.substring(0, t.maxLength - 2 - slen) + t.value.substring(cPos,slen);
                }
            }
            else if(pText.length > 0 && selectText != ""){
                 t.value = t.value.substring(0,cPos) + pText + t.value.substring(cPos + selectText.length ,slen);
            }
            //$restore SO. Trim to proper length.  Restore SI if reach maxLength for auto advance$//
            t.value = " " + t.value;
            if(t.value.length > t.maxLength - 2) {
                t.value = t.value.substring(0, t.maxLength - 1) + " ";
            }
            if(newPos != 0) {                    //$$IC59163$$//
                var range = t.createTextRange(); //$$IC59163$$//
                range.move('character',newPos+1);//$$IC59163$$//
                range.select();                  //$$IC59163$$//
                newPos = 0                       //$$IC59163$$//
            }                                    //$$IC59163$$//
            updateCursorPosition(false,null);    //$$IC59163$$//
            event.returnValue = false;
            return;
        }else if(isIE && enableDBCSSession && element.getAttribute("eliminateMaxlengthInIdeographicFields") == "true") {
          //if(autoAdvance && showUnProtectedSosiAsSpace && (event.type == "keyup" && code == 13) && getCurrentPosition() == element.value.length) {  //$$IC59165$$//
            if(autoAdvance && showUnProtectedSosiAsSpace && (event.type == "keyup" && !isIMEstate) && getCurrentPosition() == element.value.length) { //$$IC59165$$//
                var nText = removeSpaces(element.value);                                                                      //$$38158$$//
                nText = verifyText(nText,ck);                                                                                 //$$38158$$//
              //element.value = nText;                                                                                        //$$38158 IC59379del$$//
              //dataLengthCheckingForDBCSOnly(element,true);                                                                  //$$38158 IC59379del$$//
                dataLengthCheckingForDBCSOnly(element, nText, true);                                                          //$$IC59379//$$
            }                                                                                                                 //$$38158$$//
            else {                                                                                                            //$$38158$$//
              //if((event.type == "keydown" && code == 9) || (event.type == "keyup" && code == 13) || event.type == "blur") { //$$38158 IC59165del$$//
                if((event.type == "keydown" && code == 9) || (event.type == "keyup" && !isIMEstate) || event.type == "blur") {//$$IC59165$$//
                    var nText = removeSpaces(element.value);                                                                  //$$38158$$//
                    nText = verifyText(nText,ck);                                                                             //$$38158$$//
                  //element.value = nText;                                                                                    //$$38158 IC59379del$$//
                  //dataLengthCheckingForDBCSOnly(element,false);                                                             //$$38158 IC59379del$$//
                    dataLengthCheckingForDBCSOnly(element, nText, false);                                                     //$$IC59379$$//
                }                                                                                                             //$$38158$$//
            }                                                                                                                 //$$38158$$//
        } else if(enableDBCSSession && ((event.type == "keydown" && (code == 13 || code == 19 || code == 27 || code == 33 || code == 34 || (code > 111 && code < 124))) //$check keydown for submit, include ENTER and PF keys$//
                                         || (event.type == "keyup" && code == 13)  //$check keyup for ENTER, this is for L2 IME submit action$//
                                         || event.type == "click" || event.type == "blur")) { //$Check the text in the field is valid for click and blur$//

            var t = (isIE) ? event.srcElement : event.target;

            var nText = removeSpaces(t.value); //$trim SBCS spaces in original text$//
            nText = verifyText(nText,ck); //$content check, remove invalid text$//
            //$$38841 start$$//
            if(CodePage == 1390 || CodePage == 1399) {
                var isWithinInputSize = false;
                var isAlmostWithinInputSize = false;
                var i = nText.length - 1;
                if(countDataLengthForDBCS(nText) > ilen - 2) {
                    while(isWithinInputSize == false && i > -1) {
                        if (isAlmostWithinInputSize == true) {
                            isWithinInputSize = true;
                            break;
                        }
                            //if last character is surrogate character, remove high and low character together
                        if(isSurrogate(nText.substr(value.length-2,1), nText.substr(value.length-1,1))) { //james
                            i--;
                            nText = nText.substr(0, i);
                        } else {
                                nText = nText.substr(0, i);
                        }
                        if (countDataLengthForDBCS(nText) <= ilen - 2) {
                            isAlmostWithinInputSize = true;
                        }
                            i--;
                    }
                }
            }
            else { //$$38841 end$$//
                if(nText.length > t.maxLength - 2) { //$trim text too long, the DBCS count can only be maxLength -2$//
                    nText = nText.substring(0, t.maxLength - 2);
                }
            }

            var isValid = false; //$check need to replace text in the field or not$//
            if(nText == t.value) isValid = true; //$If original text is identical to processed one, no modification$//

            nText = " " + nText;
            if(nText == t.value) isValid = true; //$If original text is identical to processed one, no modification$//

            if(nText.length == t.maxLength - 1) { //$reach text max length, trigger auto advance$//
              nText = nText + " ";
              if(nText == t.value) isValid = true;
            }

            if(!isValid) {
                t.value = nText;
                if(isIE) {
                    event.returnValue = false;
                }
                else {
                    event.returnValue = false; //$Although there is no returnValue in mozilla, we add this attribute and set it to false to stop submit action$//
                    event.preventDefault();
                }
            }
        }
    }
    else { //$for keypress event, means try to insert SBCS to J-field. Or for show SOSI off, apply G field algorithm$//
       allowGField(event);
    }
}

// Allows only DBCS character event for IE Mobile
function allowJFieldForIEMobile(inputbox)
{
    if(showUnProtectedSosiAsSpace) {
        //$Verify the text character by character with the "ck" function$//
        var verifyText = function(inStr, ck) {
            var outStr = "";
            for (var i=0; i< inStr.length; i++)
            {
              if (ck(inStr.charCodeAt(i))) outStr += inStr.charAt(i);
              else break;
            }
            return outStr;
        };

        //$function to remove any SBCS spaces in string$//
        var removeSpaces = function(inStr) {
          var outStr = "";
          for (var i=0; i< inStr.length; i++) {
            if (inStr.charCodeAt(i) != 32) outStr += inStr.charAt(i);
          }
          return outStr;
        };

        var ck = function(code) {
            if (isDBCSChar(String.fromCharCode(code), enableDBCSSession, enableDBCSEuro, CodePage)) return true;
            return false;
        };

        if(enableAutoConvertSBCStoDBCS) {
            var content = inputbox.value;
            var data = "";
            for(var a = 0; a < content.length; a++) {
                var code = content.charCodeAt(a);
                if(code == 32) {
                    code = 0x3000;
                }
                else if(code >= 33 && code <=126) {
                    code = 65281 + (code - 33);
                }
                data += String.fromCharCode(code);
            }
            inputbox.value = data;
        }

        var t = inputbox;
        var nText = removeSpaces(t.value); //$trim SBCS spaces in original text$//
        nText = verifyText(nText,ck); //$content check, remove invalid text$//
        if(nText.length > t.maxLength - 2) { //$trim text too long, the DBCS count can only be maxLength -2$//
            nText = nText.substring(0, t.maxLength - 2);
        }

        var isValid = false; //$check need to replace text in the field or not$//
        if(nText == t.value) isValid = true; //$If original text is identical to processed one, no modification$//

        nText = " " + nText;
        if(nText == t.value) isValid = true; //$If original text is identical to processed one, no modification$//

        if(nText.length == t.maxLength - 1) { //$reach text max length, trigger auto advance$//
            nText = nText + " ";
            if(nText == t.value) isValid = true;
        }

        if(!isValid) {
            t.value = nText;
        }
    }
    else {
        allowGFieldForIEMobile(inputbox);
    }
}

function allowAlphaNumericShift(event) {
    event = (event) ? event : ((window.event) ? window.event : ""); //$$38158$$//
    var code = event.keyCode ? event.keyCode : event.which;         //$$38158$$//
    var element = (isIE) ? event.srcElement : event.target;         //$$38158$$//
    var iname = element.name;                                       //$$38158$$//
    var ipool = iname.split("_");                                   //$$38158$$//
    var ipos = parseInt(ipool[1]);                                  //$$38158$$//
    var ilen = parseInt(ipool[2]);                                  //$$38158$$//

        var ck = function(code) {
        if (isDBCSChar(String.fromCharCode(code), enableDBCSSession, enableDBCSEuro, CodePage)) return false;
                return true;
    };
    contentCheck(event, ck);
    if(isIE && enableDBCSSession && element.getAttribute("eliminateMaxlengthInIdeographicFields") == "true") {            //$$38158$$//
      //if(autoAdvance && (event.type == "keyup" && code == 13) && getCurrentPosition() == element.value.length) {        //$$38158add IC58284del$$//
      //if(autoAdvance && (event.type == "keyup" && (code == 13 || !isIMEstate)) && getCurrentPosition() == element.value.length && (hatsForm != null && hatsForm.style.visibility != 'hidden')) {//$$IC58284 IC59165del$$//
        if(autoAdvance && (event.type == "keyup" && !isIMEstate) && getCurrentPosition() == element.value.length && (hatsForm != null && hatsForm.style.visibility != 'hidden')) {//$$IC59165$$//
            if(element.value.length == ilen) {                                                                            //$$38158$$//
                nextInputField(element, ipos, ilen);                                                                      //$$38158$$//
            }                                                                                                             //$$38158$$//
            else if(element.value.length > ilen) {                                                                        //$$38158$$//
                //var data="";                                                                                            
                //try{                                                                                                    
                //    if(clipboardData){                                                                                  //$$IC58950del$$//
                //        clipboardData.clearData("Text");                                                                //$$38158add IC58950del$$//
                //        clipboardData.setData("Text", element.value.substring(ilen));                                   //$$38158add IC58950del$$//
                //    }                                                                                                   //$$IC58950$$//
                //}catch(e){}                                                                                             
                //exceedString = true;                                                                                    //$$38158$$//
                exceedString = element.value.substring(ilen);                                                             //$$IC58950$$//
                element.value = element.value.substring(0,ilen);                                                          //$$38158$$//
                nextInputField(element, ipos, ilen);                                                                      //$$38158$$//
            }                                                                                                             //$$38158$$//
        }                                                                                                                 //$$38158$$//
        else {                                                                                                            //$$38158$$//
          //if((event.type == "keydown" && code == 9) || (event.type == "keyup" && code == 13) || event.type == "blur") { //$$38158 IC59165del$$//
            if((event.type == "keydown" && code == 9) || (event.type == "keyup" && !isIMEstate) || event.type == "blur") {//$$IC59165$$//
                if(element.value.length > ilen) {                                                                         //$$38158$$//
                    element.value = element.value.substring(0,ilen);                                                      //$$38158$$//
                }                                                                                                         //$$38158$$//
            }                                                                                                             //$$38158$$//
        }                                                                                                                 //$$38158$$//
    }                                                                                                                     //$$38158$$//
}

function allowAlphaNumericShiftForIEMobile(inputbox) {
        var ck = function(code) {
        if (isDBCSChar(String.fromCharCode(code), enableDBCSSession, enableDBCSEuro, CodePage)) return false;
                return true;
    };
    contentCheckForIEMobile(inputbox, ck);
}

function allowKatakanaShift(event) {
    allowAlphaNumericShift(event);
}

function allowKatakanaShiftForIEMobile(inputbox) {
    allowAlphaNumericShiftForIEMobile(inputbox);
}

// Allows only SBCS character event
function allowSBCSOnly(event) {}

function allowSBCSOnlyForIEMobile(inputbox) {}

function allowDBCSEither(event) {
    event = (event) ? event : ((window.event) ? window.event : "");
        var code = event.keyCode ? event.keyCode : event.which;
    var element = (isIE) ? event.srcElement : event.target;
    var isJFieldMode = element.getAttribute("jFieldMode");

    var ck = function (firstCharCode, element) { //$adjust length and execute content checking accroding to content$//
        if(isDBCSChar(String.fromCharCode(firstCharCode), enableDBCSSession, enableDBCSEuro, CodePage)) {
            if(isIE && enableDBCSSession && element.getAttribute("eliminateMaxlengthInIdeographicFields") == "true") { //$$38158$$//
            //no thing to do                                                                                           //$$38158$$//
            } else if(CodePage == 1390 || CodePage == 1399 ) { //$$38841$//
            //no thing to do
            } else {                                                                                                   //$$38158$$//
                if(showUnProtectedSosiAsSpace) {
                    element.maxLength = element.size /2 + 1;
                } else {
                    element.maxLength = element.size /2 - 1;
                }
            } //$$38158 add$$//
            element.style.imeMode = "active";
            allowJField(event);
            element.setAttribute("currentJFieldMode", "true");
        } else {
            element.maxLength = element.size;
            element.style.imeMode = "inactive";
            allowAlphaNumericShift(event);
            element.setAttribute("currentJFieldMode", "false");
        }
        return;
    };


    if(isJFieldMode == "true") { //$host field is with DBCS characters, always J field mode$//
        element.setAttribute("currentJFieldMode", "true");
        allowJField(event);
        return;
    }

    if(element.value.length > 0 && !(element.value.length == 1 && showUnProtectedSosiAsSpace && element.value.charCodeAt(0) == 32)) { //$host field is not empty, switch to AlphaNumericShift or J-field mode depends on first character$//
        var firstCharCode = element.value.charCodeAt(0);
        if(showUnProtectedSosiAsSpace && firstCharCode == 32 && element.value.length > 1) {
            firstCharCode = element.value.charCodeAt(1);
        }
        ck(firstCharCode, element);
    } else if(event.type == "paste" || event.type == "drop" || (event.type = "focus" && exceedString != null)) { //$host field is empty and user paste data, check the data pasted$// //$$38158 modify$$//
        var pText = "";
        if(event.type == "paste"){
            var data="";
            try{
                if(clipboardData){
                    data=clipboardData.getData("Text");
                }
                if(data){
                    pText = data;
                }
            }catch(e){}
            //pText = clipboardData.getData("Text");
        }
        if(event.type == "drop"){
            var data="";
            try{
                if(event.dataTransfer){
                    data=event.dataTransfer.getData("Text");
                }
                if(data){
                    pText = data;
                }
            }catch(e){}
            //pText = event.dataTransfer.getData("Text");
        }
        if(event.type == "focus" && exceedString != null){
            //var data="";                                
            //try{                                        
            //    if(clipboardData){                      //$$IC58950del$$//
            //        data=clipboardData.getData("Text"); //$$IC58950del$$//
            //    }                                       //$$IC58950del$$//
            //    if(data){                               //$$IC58950del$$//
            //        pText = data;                       //$$IC58950del$$//
            //    }                                       //$$IC58950del$$//
            //}catch(e){}                                 
            //pText = clipboardData.getData("Text");      //$$38158 IC56690del$$//
            pText = exceedString;                         //$$IC58950add$$//
            exceedString = null;                          //$$IC58950add$$//
        }
        if(pText.length > 0) {
            var firstCharCode = pText.charCodeAt(0);
            if(showUnProtectedSosiAsSpace && firstCharCode == 32 && pText.length > 1) {
                firstCharCode = pText.charCodeAt(1);
            }
            ck(firstCharCode, element);
        }
    }
}

function allowDBCSEitherForIEMobile(inputbox) {
    var element = inputbox;
    var isJFieldMode = element.getAttribute("jFieldMode");

    var ck = function (firstCharCode, element) { //$adjust length and execute content checking accroding to content$//
        if(isDBCSChar(String.fromCharCode(firstCharCode), enableDBCSSession, enableDBCSEuro, CodePage)) {
            if(showUnProtectedSosiAsSpace) {
                element.maxLength = element.size /2 + 1;
            } else {
                element.maxLength = element.size /2 - 1;
            }
            element.style.imeMode = "active";
            allowJField(event);
            element.setAttribute("currentJFieldMode", "true");
        } else {
            element.maxLength = element.size;
            element.style.imeMode = "inactive";
            allowAlphaNumericShiftForIEMobile(element);
            element.setAttribute("currentJFieldMode", "false");
        }
        return;
    };


    if(isJFieldMode == "true") { //$host field is with DBCS characters, always J field mode$//
        element.setAttribute("currentJFieldMode", "true");
        allowJFieldForIEMobile(element);
        return;
    }

    if(element.value.length > 0 && !(element.value.length == 1 && showUnProtectedSosiAsSpace && element.value.charCodeAt(0) == 32)) { //$host field is not empty, switch to AlphaNumericShift or J-field mode depends on first character$//
        var firstCharCode = element.value.charCodeAt(0);
        if(showUnProtectedSosiAsSpace && firstCharCode == 32 && element.value.length > 1) {
            firstCharCode = element.value.charCodeAt(1);
        }
        ck(firstCharCode, element);
    }
}

function addPseudoSOSI(pseudoSO, pseudoSI, objValue) {
    var modifiedValue = "";
    var inputValue = new String(objValue);
    var inputValueLength = inputValue.length;
    if (inputValue != null) {
       for (var j=0; j<inputValueLength; j++) {
            var currentString = inputValue.substr(j,1);
            var nextCurrentString = inputValue.substr(j+1,1);
            if (parseInt(j+1) >= inputValueLength)
                nextCurrentString = null;
            // case 1 : if first character is DBCS, add pseudoSO
            if (isDBCSChar(currentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
               if (j == 0)
                   modifiedValue = modifiedValue + "" + pseudoSO + "" + currentString;
               if (parseInt(j+1) == inputValueLength) {
                   if (j == 0)
                      currentString = "";
                   modifiedValue = modifiedValue + "" + currentString;
               }
               if (j >=0 && parseInt(j+1) != inputValueLength) {
                   if (nextCurrentString != null && !isDBCSChar(nextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
                       if (j == 0)
                          currentString = "";
                       modifiedValue = modifiedValue + "" + currentString + pseudoSI;
                   } else {
                       if (j == 0)
                           currentString = "";
                       modifiedValue = modifiedValue + "" + currentString;
                   }
               }
            } else {
                 if (nextCurrentString != null && isDBCSChar(nextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
                     modifiedValue = modifiedValue + "" + currentString + "" + pseudoSO;
                 } else {
                     modifiedValue = modifiedValue + "" + currentString;
                 }
            }
        }
    }
    return modifiedValue;
}
function countDataLength(pseudoSO, pseudoSI, inputValue) {
    //pseudoSO, pseudoSI and SBCS have length 1
    //only DBCS has length 2
    var stringLength = 0;
    for (var i=0; i < inputValue.length; i++) {
        var currentString = inputValue.substr(i,1);
        if (currentString == pseudoSO || currentString == pseudoSI) {
            stringLength++;
        } else {
            if (isDBCSChar(currentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
                if(i+1 < inputValue.length && isSurrogate(currentString, inputValue.substr(i+1,1))) //$$38841$$//
                    i++;                                                                            //$$38841$$//
                stringLength = stringLength + 2;
            } else {
                stringLength++;
            }
        }
    }
    return stringLength;
}

var autoAdvanceForMixedField = false; //$$IC58284 add$$//
function dataLengthChecking(pseudoSO, pseudoSI, inputValue, obj) {
    var iname = obj.name;
    var pool = iname.split("_");
    var ipos =  parseInt(pool[1]); //$$38158 add$$//
    var inputSize = parseInt(pool[2]);
    var modifiedValue = inputValue;

    var removePseudoSOSI = function(inStr) {                            //$$IC59079$$//
        var outStr = "";                                                //$$IC59079$$//
        for (var i=0; i< inStr.length; i++) {                           //$$IC59079$$//
            if (inStr.charCodeAt(i) != 30 && inStr.charCodeAt(i) != 31) //$$IC59079$$//
                outStr += inStr.charAt(i);                              //$$IC59079$$//
        }                                                               //$$IC59079$$//
        return outStr;                                                  //$$IC59079$$//
    };                                                                  //$$IC59079$$//

    if (countDataLength(pseudoSO, pseudoSI, modifiedValue) > inputSize) {
        var isWithinInputSize = false;
        var isAlmostWithinInputSize = false;
        var i = modifiedValue.length - 1;
        while(isWithinInputSize == false && i > -1) {
            //remove pseudoSO and pseudoSI, if there is no DBCS within pseudoSO and pseudoSI
            if (isAlmostWithinInputSize == true) {
                if(modifiedValue.substr(modifiedValue.length-1,1) == pseudoSI &&
                    modifiedValue.substr(modifiedValue.length-2,1) == pseudoSO) {
                    modifiedValue = modifiedValue.substr(0,modifiedValue.length -2);
                }
                isWithinInputSize = true;
                if(autoAdvance && showUnProtectedSosiAsSpace && isIE && enableDBCSSession && obj.getAttribute("eliminateMaxlengthInIdeographicFields") == "true" && getCurrentPosition() == obj.value.length) { //$$38158 add$$//
                    //var data="";                                                    
                    //try{                                                            
                    //    if(clipboardData){                                          //$$IC58950del$$//
                    //        clipboardData.clearData("Text");                        //$$38158add IC58950del$$//
                    //        clipboardData.setData("Text", inputValue.substring(i)); //$$38158add IC58950del$$//
                    //    }                                                           //$$IC58950del$$//
                    //}catch(e){}                                                     
                    //exceedString = true;                                            //$$38158add IC58950del$$//
                    //exceedString = inputValue.substring(i+1);                       //$$IC58950add$$//
                    if(isSurrogate(inputValue.substr(i,1), inputValue.substr(i+1,1))){//$$38841$$//
                        exceedString = removePseudoSOSI(inputValue.substring(i));     //$$38841$$//
                    }else                                                             //$$38841$$//
                        exceedString = removePseudoSOSI(inputValue.substring(i+1));   //$$IC59079add$$//
                }                                                                     //$$38158 add$$//
                break;
            }
            //if last character is surrogate character, remove high and low character together
            if(isSurrogate(modifiedValue.substr(modifiedValue.length-2,1), modifiedValue.substr(modifiedValue.length-1,1))) { //$$38841$$//
                i--;                                                                                                          //$$38841$$//
                modifiedValue = inputValue.substr(0, i);                                                                      //$$38841$$//
            } else {                                                                                                          //$$38841$$//
                modifiedValue = inputValue.substr(0, i);
            }
            //add pseudoSI, if the last character is DBCS or pseudoSO
            if (isDBCSChar(modifiedValue.substr(modifiedValue.length-1,1), enableDBCSSession, enableDBCSEuro, CodePage) ||
                modifiedValue.substr(modifiedValue.length-1,1) == pseudoSO) {
                modifiedValue = modifiedValue + "" + pseudoSI;
            }
            if (countDataLength(pseudoSO, pseudoSI, modifiedValue) <= inputSize) {
                isAlmostWithinInputSize = true;
            }
            i--;
        }
    }
    //$$IC58284 add start$$//
    else if(countDataLength(pseudoSO, pseudoSI, modifiedValue) == inputSize) {
        // If the last character at maxlength of the field is DBCS
        if(isDBCSChar(modifiedValue.substr(modifiedValue.length-1,1), enableDBCSSession, enableDBCSEuro, CodePage)) {        //$$IC59333$$//
            if(isSurrogate(modifiedValue.substr(modifiedValue.length-2,1), modifiedValue.substr(modifiedValue.length-1,1)))  //$$38841$$//
                //trim the last surrogate character
                modifiedValue = modifiedValue.substr(0,modifiedValue.length-2);                                              //$$38841$$//
            else                                                                                                             //$$38841$$//
                //trim the last double byte character
                modifiedValue = modifiedValue.substr(0,modifiedValue.length-1);                                              //$$IC59333$$//
            //if the new last character is SO, trim it
            if( modifiedValue.substr(modifiedValue.length-1,1)==pseudoSO)                                                    //$$IC59333$$//
                modifiedValue = modifiedValue.substr(0,modifiedValue.length-1);                                              //$$IC59333$$//
            //if the new last character is DBCS, add SI
            else if(isDBCSChar(modifiedValue.substr(modifiedValue.length-1,1), enableDBCSSession, enableDBCSEuro, CodePage)) //$$IC59333$$//
                modifiedValue == modifiedValue + "" + pseudoSI;                                                              //$$IC59333$$//
        }                                                                                                                    //$$IC59333$$//
        // Count the new data length
        if(countDataLength(pseudoSO, pseudoSI, modifiedValue) == inputSize) {                                                //$$IC59333$$//
            if(autoAdvance && showUnProtectedSosiAsSpace && isIE && enableDBCSSession && obj.getAttribute("eliminateMaxlengthInIdeographicFields") == "true" && getCurrentPosition() == obj.value.length) { //$$38158$$//
                autoAdvanceForMixedField = true;                                                                                                                                                            //$$38158$$//
            }                                                                                                                                                                                               //$$38158$$//
            else {                               //$$38795$$//
               autoAdvanceForMixedField = false; //$$38795$$//
            }                                    //$$38795$$//
        }                                        //$$IC59333$$//
    }
    else {
        autoAdvanceForMixedField = false;
    }
    //$$IC58284 add end$$//
    return modifiedValue;
}
function replacePseudoSOSI(pseudoSO, pseudoSI, inputValue) {
    var startPositionSO = inputValue.indexOf(pseudoSO);
    var startPositionSI = inputValue.indexOf(pseudoSI);
    var replaceString = "";
    if (showUnProtectedSosiAsSpace) {
        replaceString = " ";
    }
    while (startPositionSO != -1 || startPositionSI != -1) {
        inputValue = inputValue.replace(pseudoSO, replaceString);
        inputValue = inputValue.replace(pseudoSI, replaceString);
        startPositionSO = inputValue.indexOf(pseudoSO);
        startPositionSI = inputValue.indexOf(pseudoSI);
    }
    return inputValue;
}
function removeSpaceAsSOSI(modifiedValue) {
    var modifiedValue = modifiedValue;
    var temp = "";
    var modeSBCS = "SBCS";
    var modeDBCS = "DBCS";
    //mode character only SBCS or DBCS
    var modeCharacter = modeSBCS;
    var concatNextString = true;
    for (var i=0; i<modifiedValue.length;i++) {
        if (concatNextString == false) {
            concatNextString = true;
            continue;
        }
        var currentString = modifiedValue.substr(i,1);
        var nextCurrentString = modifiedValue.substr(i+1,1);
        var doubleNextCurrentString = modifiedValue.substr(i+2,1);
        var tripleNextCurrentString = modifiedValue.substr(i+3,1);
        var concatString = true;
        if (parseInt(i+1) >= modifiedValue.length)
            nextCurrentString = null;
        if (parseInt(i+2) >= modifiedValue.length)
            doubleNextCurrentString = null;
        if (parseInt(i+3) >= modifiedValue.length)
            tripleNextCurrentString = null;

        if (isDBCSChar(currentString, enableDBCSSession, enableDBCSEuro, CodePage))
            modeCharacter = modeDBCS;
        else
            modeCharacter = modeSBCS;
        if (currentString == " " && modeCharacter == modeSBCS) {
            if (nextCurrentString != null && isDBCSChar(nextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage))
                concatString = false;
        }
        if (modeCharacter == modeDBCS && nextCurrentString == " " &&  doubleNextCurrentString == null) {
            concatNextString = false;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString != null && doubleNextCurrentString != " " && !isDBCSChar(doubleNextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
            concatNextString = false;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString != null && isDBCSChar(doubleNextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
            currentString = currentString + " ";
            i++;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString == " " && tripleNextCurrentString != null &&
            isDBCSChar(tripleNextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
            currentString = currentString + "  ";
            i = i + 2;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString == " " && tripleNextCurrentString != null &&
            tripleNextCurrentString != " " &&
            !isDBCSChar(tripleNextCurrentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
            currentString = currentString + " ";
            i = i + 2;
        } else if (modeCharacter == modeDBCS && nextCurrentString == " " &&
            doubleNextCurrentString == " " && tripleNextCurrentString == " ") {
            currentString = currentString + " ";
            i = i + 2;
        }
        if (concatString)
            temp = temp.concat(currentString);
    }
    return temp;
}

function getCurrentPosition() {
    var caretPos = document.selection.createRange().duplicate();
    t = caretPos.parentElement();
    if (t.type!="text" && t.type!="password" && t.type!="textarea") return -1;
    var beginField = t.createTextRange();
    caretPos.collapse();
    beginField.collapse();
    var slen = t.value.length ;
    for ( pos = 0 ; pos <= slen ; pos++ )
    {
      qa =caretPos.getBoundingClientRect();
      qb = beginField.getBoundingClientRect();
      if ( qa.left == qb.left )
      {
        break;
      }
      caretPos.move("character",-1);
    }
    return pos;
}
function setCurrentPosition(cursorPosition) {
    var caretPos = document.selection.createRange();
    for ( pos = 0 ; pos < cursorPosition ; pos++ )
    {
      caretPos.move("character",1);
    }
    caretPos.select();
}
function allowDataLengthCheckingAlgorithm(event) {
    var pseudoSO = '\u001F';
    var pseudoSI = '\u001E';
    var obj = (isIE) ? event.srcElement : event.target;
    var modifiedValue = obj.value;
    var tempModifiedValue = obj.value;
    var tempValue = null; //$$IC59163$$//
    if(isIE){
        var cursorPosition = getCurrentPosition();
        //if (event.type == "paste") {
        //    var pasteValue = clipboardData.getData("Text");
        if (event.type == "paste" || event.type == "drop" || (event.type == "focus" && exceedString != null)) { //$$38158$$//
            var pasteValue = "";
            if (event.type == "paste"){
                var data="";
                try{
                    if(clipboardData){
                        data=clipboardData.getData("Text");
                    }
                    if(data){
                        pasteValue = data;
                    }
                }catch(e){}
                //pasteValue = clipboardData.getData("Text");
            }
            if (event.type == "drop"){
                var data="";
                try{
                    if(event.dataTransfer){
                        data=event.dataTransfer.getData("Text");
                    }
                    if(data){
                        pasteValue = data;
                    }
                }catch(e){}
                //pasteValue = event.dataTransfer.getData("Text");
            }
            if (event.type == "focus" && exceedString != null) {//$$38158 add$$//
                //var data="";                                
                //try{                                        
                //    if(clipboardData){                      //$$IC58950del$$//
                //        data=clipboardData.getData("Text"); //$$IC58950del$$//
                //    }                                       //$$IC58950del$$//
                //    if(data){                               //$$IC58950del$$//
                //        pasteValue = data;                  //$$IC58950del$$//
                //    }                                       //$$IC58950del$$//
                //}catch(e){}                                 
                //pasteValue = clipboardData.getData("Text"); //$$38158add IC56690del$$//
                //exceedString = false;                       //$$38158 add$$//
                pasteValue = exceedString;                    //$$IC58950add$$//
                exceedString = null;                          //$$IC58950add$$//
            }                                                 //$$38158 add$$//
            var beginString = "";
            var endString = "";
            if (parseInt(cursorPosition) > 0 && modifiedValue.length > 0) {
                beginString = modifiedValue.substr(0, cursorPosition);
            }
            if (overwritemodeenabled) {
                var endStringLength = parseInt(modifiedValue.length - cursorPosition + pasteValue.length);
                if (parseInt(endStringLength) >= 0) {
                    endString = modifiedValue.substr(parseInt(cursorPosition + pasteValue.length), endStringLength);
                }
            } else {
                endString = modifiedValue.substr(parseInt(cursorPosition), modifiedValue.length - cursorPosition);
            }
            if (pasteValue != null && pasteValue != "") {
                modifiedValue = beginString + "" + pasteValue + "" + endString;
                tempValue = beginString + "" + pasteValue; //$$IC59163$$//
            }
            if(isIE) {
                      event.returnValue = false;
                  } else {
                event.preventDefault();
                  }
        }
    }
    if (showUnProtectedSosiAsSpace) {
        modifiedValue = removeSpaceAsSOSI(modifiedValue);
        if(tempValue != null) tempValue = removeSpaceAsSOSI(tempValue); //$$IC59163$$//
    }
    modifiedValue = addPseudoSOSI(pseudoSO, pseudoSI, modifiedValue);
    modifiedValue = dataLengthChecking(pseudoSO, pseudoSI, modifiedValue, obj);
    modifiedValue = replacePseudoSOSI(pseudoSO, pseudoSI, modifiedValue);
    if(tempValue != null) tempValue = addPseudoSOSI(pseudoSO, pseudoSI, tempValue);           //$$IC59163$$//
    if(tempValue != null) tempValue = dataLengthChecking(pseudoSO, pseudoSI, tempValue, obj); //$$IC59163$$//
    if(tempValue != null) tempValue = replacePseudoSOSI(pseudoSO, pseudoSI, tempValue);       //$$IC59163$$//
    if (tempModifiedValue != modifiedValue) {
        obj.value = modifiedValue;
        if(isIE && tempValue != null) {               //$$IC59163$$//
            var range = obj.createTextRange();        //$$IC59163$$//
            range.move('character',tempValue.length); //$$IC59163$$//
            range.select();                           //$$IC59163$$//
            updateCursorPosition(false,null);         //$$IC59163$$//
        }                                             //$$IC59163$$//
//        setCurrentPosition(cursorPosition);
    }
    //if(exceedString) {                                                                                                                     //$$38158 IC58284del$$//
    //if(exceedString != null || (autoAdvanceForMixedField && event.type == "keyup" && !isIMEstate)) {                                       //$$IC58284 IC59379del$$//
      if((exceedString != null && event.type == "keyup" && !isIMEstate && (hatsForm != null && hatsForm.style.visibility != 'hidden')) ||    //$$IC59379$$//
         (autoAdvanceForMixedField && event.type == "keyup" && !isIMEstate && (hatsForm != null && hatsForm.style.visibility != 'hidden'))) {//$$IC59379$$//
        var iname = obj.name;                 //$$38158$$//
        var pool = iname.split("_");          //$$38158$$//
        var ipos = parseInt(pool[1]);         //$$38158$$//
        var inputSize = parseInt(pool[2]);    //$$38158$$//
        nextInputField(obj, ipos, inputSize); //$$38158$$//
    }                                         //$$38158$$//
}

function allowDataLengthChecking(event) {
    var code = event.keyCode ? event.keyCode : event.which;
    var obj = (isIE) ? event.srcElement : event.target; //$$IC58284 add$$//

    if (autoAdvance && showUnProtectedSosiAsSpace && isIE && enableDBCSSession && obj.getAttribute("eliminateMaxlengthInIdeographicFields") == "true" && (event.type == "keyup" && !isIMEstate) && getCurrentPosition() == obj.value.length && (hatsForm != null && hatsForm.style.visibility != 'hidden')) { //$$IC59379$$//
        allowDataLengthCheckingAlgorithm(event);                                                                                                                                                                                                                                                              //$$IC59379$$//
    }                                                       //enter      pause/break    escape         page up       page down       F1-F12
  //if(enableDBCSSession && ((event.type == "keydown" && (code == 13 || code == 19 || code == 27 || code == 33 || code == 34 || (code > 111 && code < 124)))       //$$IC59379del$$//
    else if(enableDBCSSession && ((event.type == "keydown" && (code == 13 || code == 19 || code == 27 || code == 33 || code == 34 || (code > 111 && code < 124)))  //$$IC59379$$//
                                         || (event.type == "keyup" && code == 13)
                                         || event.type == "paste" || event.type == "click" || event.type == "blur" || event.type == "drop")) {
        allowDataLengthCheckingAlgorithm(event);
  //} else if (event.type == "keypress" || event.type == "paste" || event.type == "blur" || event.type == "click" || event.type == "drop") {
  //$$IC58284 add start$$//
  //} else if (autoAdvance && showUnProtectedSosiAsSpace && isIE && enableDBCSSession && obj.getAttribute("eliminateMaxlengthInIdeographicFields") == "true" && (event.type == "keyup" && !isIMEstate) && getCurrentPosition() == obj.value.length && (hatsForm != null && hatsForm.style.visibility != 'hidden')) { //$$IC59379del$$//
  //    allowDataLengthCheckingAlgorithm(event);                                                                                                                                                                                                                                                                     //$$IC59379del$$//
  //$$IC58284 add end$$//
    } else if (code == 13 || event.type == "paste" || event.type == "blur" || event.type == "click" || event.type == "drop") {
        allowDataLengthCheckingAlgorithm(event);
    } else if(event.type == "focus" && exceedString != null) { //$$38158 add$$//
        allowDataLengthCheckingAlgorithm(event);               //$$38158 add$$//
    }                                                          //$$38158 add$$//

}

//for IE Mobile
function allowDataLengthCheckingForIEMobile(inputbox) {
    var pseudoSO = '\u001F';
    var pseudoSI = '\u001E';
    var obj = inputbox;
    var modifiedValue = obj.value;
    var tempModifiedValue = obj.value;
    if (showUnProtectedSosiAsSpace) {
        modifiedValue = removeSpaceAsSOSI(modifiedValue);
    }
    modifiedValue = addPseudoSOSI(pseudoSO, pseudoSI, modifiedValue);
    modifiedValue = dataLengthChecking(pseudoSO, pseudoSI, modifiedValue, obj);
    modifiedValue = replacePseudoSOSI(pseudoSO, pseudoSI, modifiedValue);
    if (tempModifiedValue != modifiedValue) {
        obj.value = modifiedValue;
    }
}
//$$38158 add$$//
function countDataLengthForDBCS(inputValue){
    var stringLength = 0;
    for (var i=0; i < inputValue.length; i++) {
        var currentString = inputValue.substr(i,1);
        if (isDBCSChar(currentString, enableDBCSSession, enableDBCSEuro, CodePage)) {
            if(i+1 < inputValue.length && isSurrogate(currentString, inputValue.substr(i+1,1))) //$$38841$$//
                i++;                                                                            //$$38841$$//
            stringLength = stringLength + 2;
        }
    }
    return stringLength;
}

//function dataLengthCheckingForDBCSOnly(inputbox, autoAdvance) {           //$$IC59379del$$//
function dataLengthCheckingForDBCSOnly(inputbox, inputValue, autoAdvance) { //$$IC59379$$//
    var iname = inputbox.name;
    var pool = iname.split("_");
    var inputSize = parseInt(pool[2])-2;
  //var data = inputbox.value; //$$IC59379del$$//
    var data = inputValue;     //$$IC59379$$//
    var stringLength = countDataLengthForDBCS(data);
    if(stringLength > inputSize) {
        var isWithinInputSize = false;
        var i = data.length - 1;
        while(isWithinInputSize == false && i > -1) {
            modifiedValue = data.substr(0, i);
            stringLength = countDataLengthForDBCS(modifiedValue);
            if (stringLength <= inputSize) {
                isWithinInputSize = true;
                if(autoAdvance) {
                    //try{                                                   
                    //    if(clipboardData){                                 //$$IC58950del$$//
                    //        clipboardData.clearData("Text");               //$$38158add IC58950del$$//
                    //        clipboardData.setData("Text", data.substr(i)); //$$38158add IC58950del$$//
                    //    }                                                  //$$IC58950del$$//
                    //}catch(e){}                                            
                    //clipboardData.clearData("Text");                       //$$IC56690add IC58950del$$//
                    //clipboardData.setData("Text", data.substr(i));         //$$IC56690add IC58950del$$//
                    //exceedString = true;                                   //$$IC58950del$$//
                    if(isSurrogate(data.substr(i-1,1), data.substr(i,1))){   //$$38841$$//
                        exceedString = data.substr(i-1);                     //$$38841$$//
                    }else                                                    //$$38841$$//
                        exceedString = data.substr(i);                       //$$IC58950add$$//
                }
            }
            i--;
        }
        stringLength = stringLength+2;
        if (showUnProtectedSosiAsSpace)
            inputbox.value = " "+modifiedValue+" ";
        else
            inputbox.value = modifiedValue;
      //if(exceedString != null)                                                                //$$IC59379del$$//
        if(exceedString != null && (hatsForm != null && hatsForm.style.visibility != 'hidden')) //$$IC59379$$//
            nextInputField(inputbox, parseInt(pool[1]), parseInt(pool[2]));
    }
    else if(stringLength == inputSize) {
        if (showUnProtectedSosiAsSpace) {
          //inputbox.value = " "+data+" ";                                                 //$$IC59379del$$//
            data = " "+data+" ";                                                           //$$IC59379$$//
          //if(autoAdvance)                                                                //$$IC59379del$$//
            if(autoAdvance && (hatsForm != null && hatsForm.style.visibility != 'hidden')) //$$IC59379$$//
                nextInputField(inputbox, parseInt(pool[1]), parseInt(pool[2]));
        }
        //else                       //$$IC59379del$$//
        //    inputbox.value = data; //$$IC59379del$$//

        //$Check need to replace text in the field or not. If original text is identical to processed one, no modification$//
        var isValid = false;                       //$$IC59379$$//
        if(data == inputbox.value) isValid = true; //$$IC59379$$//
        if(!isValid) {                             //$$IC59379$$//
            inputbox.value = data;                 //$$IC59379$$//
            event.returnValue = false;             //$$IC59379$$//
        }                                          //$$IC59379$$//
    }
    else {
        if (showUnProtectedSosiAsSpace)
            data = " "+data;                       //$$IC59379$$//
      //    inputbox.value = " "+data;             //$$IC59379del$$//
      //else                                       //$$IC59379del$$//
      //    inputbox.value = data;                 //$$IC59379del$$//

        //$Check need to replace text in the field or not. If original text is identical to processed one, no modification$//
        var isValid = false;                       //$$IC59379$$//
        if(data == inputbox.value) isValid = true; //$$IC59379$$//
        if(!isValid) {                             //$$IC59379$$//
            inputbox.value = data;                 //$$IC59379$$//
            event.returnValue = false;             //$$IC59379$$//
        }                                          //$$IC59379$$//
    }
}

function dataLengthCheckingForDBCSPure(inputbox, autoAdvance) {
    var iname = inputbox.name;
    var pool = iname.split("_");
    var ipos = parseInt(pool[1]);
    var inputSize = parseInt(pool[2]);
    var data = inputbox.value;
    var stringLength = countDataLengthForDBCS(data);
    if(stringLength > inputSize) {
        var isWithinInputSize = false;
        var i = data.length - 1;
        while(isWithinInputSize == false && i > -1) {
            modifiedValue = data.substr(0, i);
            stringLength = countDataLengthForDBCS(modifiedValue);
            if (stringLength <= inputSize) {
                isWithinInputSize = true;
                if(autoAdvance) {
                    //try{                                                   
                    //    if(clipboardData){                                 //$$IC58950del$$//
                    //        clipboardData.clearData("Text");               //$$38158add IC58950del$$//
                    //        clipboardData.setData("Text", data.substr(i)); //$$38158add IC58950del$$//
                    //    }                                                  //$$IC58950del$$//
                    //}catch(e){}                                            
                    //clipboardData.clearData("Text");                       //$$IC56690add IC58950del$$//
                    //clipboardData.setData("Text", data.substr(i));         //$$IC56690add IC58950del$$//
                    //exceedString = true;                                   //$$IC58950del$$//
                    if(isSurrogate(data.substr(i-1,1), data.substr(i,1))){   //$$38841$$//
                        exceedString = data.substr(i-1);                     //$$38841$$//
                    }else                                                    //$$38841$$//
                        exceedString = data.substr(i);                       //$$IC58950add$$//
                }
            }
            i--;
        }
        inputbox.value = modifiedValue;
        //if(exceedString != null)                                                              //$$IC59379del$$//
        if(exceedString != null && (hatsForm != null && hatsForm.style.visibility != 'hidden')) //$$IC59379$$//
            nextInputField(inputbox, ipos, inputSize);
    }
    //else if(stringLength == inputSize && autoAdvance) {                                                              //$$IC59379del$$//
    else if(stringLength == inputSize && autoAdvance && (hatsForm != null && hatsForm.style.visibility != 'hidden')) { //$$IC59379$$//
        nextInputField(inputbox, ipos, inputSize);
    }
}
//$$38158 add end$$//