<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">

<%@ page contentType="text/html;charset=UTF-8" isErrorPage="false" %>
<%@ page import="java.text.*,  java.util.*, com.ibm.hats.util.*, com.ibm.hats.common.*, com.ibm.hats.runtime.*" %>
<%@ taglib uri="/WEB-INF/classes/tld/hats.tld" prefix="HATS" %>
<% 
  HttpSession httpSession = request.getSession(false);
  String disconnectWhy = (String)httpSession.getAttribute(RuntimeConstants.SESSION_STOP_KEY);
  httpSession.removeAttribute(RuntimeConstants.SESSION_STOP_KEY);
  Locale clientLocale = null;
  String appName = null;
  String stopLastAction = (String)request.getAttribute(CommonConstants.STOP_LAST_ACTION);
  TransformInfo tInfo = (TransformInfo)request.getAttribute(CommonConstants.REQ_TRANSFORMINFO);
  if (tInfo != null)
  { clientLocale = tInfo.getClientLocale();
    appName = tInfo.getAppName();
  }
  if (clientLocale == null)
  { clientLocale = (HatsLocale.getInstance().getDefaultLocale()); }
  if (Ras.anyTracing) { Ras.traceEntry("JSP:"+this.getClass().getName(), "_jspService", disconnectWhy, clientLocale); }
  HatsMsgs msgs = new HatsMsgs("runtime", clientLocale);
  String hatsWindowTitle = msgs.get("DISCONNECT_PAGE_TITLE");
  String hatsServerName = msgs.get("DISCONNECT_PAGE_SERVER");
  String hatsServerIP = msgs.get("DISCONNECT_PAGE_SERVERIP");
  String hatsDisconnectedTitle = msgs.get("DISCONNECT_PAGE_HEADER");
  String hatsDisconnectedRestart = msgs.get("DISCONNECT_PAGE_RESTART");
  String additionalInfo = msgs.get("HATS_PAGE_ADDINFO");
  String restartLabel = msgs.get("RESTART_CAPTION");
  String continueLabel = msgs.get("CONTINUE_APPLICATION_CAPTION");
  String hatsAppNameLabel = msgs.get("HATS_PAGE_APPNAME");
  String hatsCurrEventLabel = msgs.get("HATS_PAGE_CURREVT");
  String hatsErrorMoreInfoAvail = msgs.get("ERROR_PAGE_MOREINFOAVAIL");
%>

<STYLE TYPE="text/css">
 BODY  { font-family: sans-serif; }
 H1    { font-family: sans-serif; font-weight: 700; background:blue; color:white; }
 .DATE { padding-top: 10px; padding-left: 10px; padding-bottom: 10px; background:#C0C0C0; color:black; }
 .INFO { font-size: .8em; padding-top: 10px; padding-left: 10px; padding-bottom: 10px; background:#C0C0C0; color:black; }
</STYLE>
<!-- submit form data by JavaScript -->
<SCRIPT>
        function ms_discon(hatsForm)
        {
            if(hatsForm.SUBMITTED.value=='true') {
            return;
            }
        hatsForm.SUBMITTED.value='true';        
        hatsForm.method='get';
        hatsForm.submit();
        }

</SCRIPT>
<!-- submit form data by JavaScript -->


<H1><%= hatsDisconnectedTitle %></H1>

<!-- Print date -->
<TABLE WIDTH=100% BORDER=0 CELLPADDING=10><TR><TD WIDTH=30%>&nbsp;</TD><TD CLASS=DATE>
<%
  DateFormat df = DateFormat.getDateTimeInstance(DateFormat.FULL, DateFormat.MEDIUM, clientLocale);
  out.println("<P>"+ df.format(new java.util.Date()) + "</P>");
%>
</TD></TR><TR><TD COLSPAN=2>

<!-- Give reason for stopping -->
<%
  if (disconnectWhy == null) /* no specific disconnect reason given */
  {
    out.println("<P>" + msgs.get("DISCONNECT_PAGE_ONEOF") + "<UL><LI>" +
                msgs.get("DISCONNECT_PAGE_BUTTON") + "<LI>" +
                msgs.get("DISCONNECT_PAGE_TIMEOUT") + "<LI>" +
                msgs.get("DISCONNECT_PAGE_ERROR") + "<LI>" +
                msgs.get("DISCONNECT_PAGE_LOGOFF") + "</UL>");
  }
  else {
    out.println("<P>" + msgs.get(disconnectWhy));
  }

  // Ending other than by disconnect button means there may be additional (error) info below.
  if (!("DISCONNECT_PAGE_BUTTON".equals(disconnectWhy)))
  { out.println(hatsErrorMoreInfoAvail); }

%>
<!--<FORM METHOD="GET" ACTION= <%= "\"" + request.getContextPath() + "/" + CommonConstants.DEFAULT_ACCESS_SERVLET_NAME + "\""%> >-->
<HATS:Form>
<%if (stopLastAction!=null) 
  { 
    /* add in previous parameter overrides */
    if( request.getAttribute(RuntimeConstants.OVERRIDE_PARAMS_STORAGE) !=null){
        Properties p=(Properties) request.getAttribute(RuntimeConstants.OVERRIDE_PARAMS_STORAGE);
        for (Enumeration e = p.keys(); e.hasMoreElements(); ) {
           String name = (String)e.nextElement();
           String value =p.getProperty(name);
           out.println("<input type=\"hidden\" name=\"" + name + "\" value=\"" + value + "\">");
        }
    }   
    // Restart information
    out.println("<P>" + hatsDisconnectedRestart);

%>
<P><INPUT TYPE='BUTTON' NAME='HATS_restart' CLASS='ApplicationButton' VALUE='<%=restartLabel%>' onClick="ms_discon(this.form)" />
<INPUT TYPE='HIDDEN' NAME='SUBMITTED' VALUE='false'> </P>
<%
  }
  else 
  {  /* if we have more actions, display Continue button */
%>
<INPUT TYPE="HIDDEN" NAME="COMMAND" VALUE="Continue" />
<P><INPUT TYPE='BUTTON' NAME='HATS_continue' CLASS='ApplicationButton' VALUE='<%=continueLabel%>' onClick="ms_discon(this.form)" style="width: auto" />
<INPUT TYPE='HIDDEN' NAME='SUBMITTED' VALUE='false'> </P>
<% 	 	
  }
%>
</HATS:Form>
</TD></TR>

<!-- Additional information -->
<TR><TD COLSPAN=2 CLASS=INFO>
<%
  try
  {
    out.println("<H3>" + hatsWindowTitle + "</H3>");
    java.net.InetAddress myNetAddress = java.net.InetAddress.getLocalHost();
    out.println(hatsServerName + " " + myNetAddress.getHostName());
    out.println("<BR>" + hatsServerIP + " " + myNetAddress.getHostAddress());
    out.println("<BR>" + hatsAppNameLabel + " " + appName);

    java.util.List errorMessages = (java.util.List)request.getAttribute(CommonConstants.HATS_ERROR_PAGE_MSGS);
    if ( (errorMessages != null) && ( errorMessages.size() > 0 ))
    {
      String currentEventDescription = (String)request.getAttribute(CommonConstants.HATS_CURREVENT_DESC);
      if (currentEventDescription != null)
      {
        out.println("<BR>" + hatsCurrEventLabel + " " + currentEventDescription);
      }

      out.println("<BR>" + additionalInfo + "<UL>");
      for (Iterator iter = errorMessages.iterator(); iter.hasNext(); )
      {
        Object o = iter.next();
        if (o instanceof Throwable)
          out.println("<LI><XMP>" + Util.getStackTrace((Throwable)o) + "</XMP>");
        else
          out.println("<LI>"+ (String)o);
      }
      out.println("</UL>");
      errorMessages.clear();
    }
  }
  catch (Exception e ) {}
%>
</TD></TR></TABLE>